--iTEAM - GISED
--Created:
--Revised:

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;
use ieee.std_logic_textio.all;
use std.textio.all;
use work.lyp4x6r4z_pkg.all;

entity lyp4x6r4z_pnu6i_tsb is
end lyp4x6r4z_pnu6i_tsb;

architecture tb of lyp4x6r4z_pnu6i_tsb is
	-- Component declaration of the tested unit
	component lyp4x6r4z_pnu6i is
		generic(latency : integer:=1);                   --clock cycles latency : 1 to 1
		port(id_lnold : in p_type_a6xQLstd;          --lambda old(n) : ql
			  ic_init : in std_logic;                  --initialize control signal
			  id_dloop : in std_logic_vector(4 downto 0);-- 
			  od_decn : out std_logic_vector(0 to 5); --dec(n) : s[1 0]
			  od_lnnew : out p_type_a6xQLstd;         --lambda new(n) : ql
			  clk : in std_logic);                     --clock signal
	end component;
	-- types
	type type_a6x4std is array(0 to 5) of std_logic_vector(3 downto 0);
	type type_a6x7std is array(0 to 5) of std_logic_vector(6 downto 0);
	-- Stimulus signals - signals mapped to the input and inout ports of tested entity
	signal id_lnold: p_type_a6xQLstd:= (others => (others => '0'));
	signal ic_init: std_logic:= '0';
	signal id_dloop: std_logic_vector (4 downto 0):= (others=>'0');
	signal clk: std_logic:= '0';
	-- Observed signals - signals mapped to the output ports of tested entity
	signal od_decn: std_logic_vector(0 to 5);
	signal od_lnnew: p_type_a6xQLstd;
	-- Test signals
	constant clkP: time:= 20 ns;
	signal enaI,enaI_r: std_logic:= '0';
	signal ld_sub_it,ld_sub_it_r: std_logic_vector(2 downto 0):= (others=>'0');
	signal od_decn_f,od_decn_c: std_logic_vector(0 to 5):= (others => '0');
	signal ld_zn_f,ld_zn,ld_yr_f,ld_yr: std_logic_vector(0 to 5):= (others => '0');
	signal ld_En_f,ld_En: type_a6x7std:= (others => (others => '0'));
	signal od_lnnew_f: p_type_a6xQLstd:= (others => (others => '0'));
	signal od_sm_f,od_parity_f,od_parity_c: std_logic:= '0';
	signal od_wmn_f: std_logic_vector (0 to 5):= (others => '0');
	signal ld_En_it_f: type_a6x4std:= (others => (others => '0'));
	signal cnt_zn_error,cnt_yr_error,cnt_En_error,cnt_decn_error: integer:= 0;
	--
	signal end_sim: std_logic:= '0';
begin
	-- Unit Under Test port map
	UUT : lyp4x6r4z_pnu6i
	generic map(latency => 1)
	port map(id_lnold => id_lnold,
				ic_init => ic_init,
				id_dloop => id_dloop,
				od_decn => od_decn,
				od_lnnew => od_lnnew,
				clk => clk);
	-- Stimulus
	clk <= not clk after clkP/2;
	ic_init <= '1' after clkP*(8+4)+clkP/2+clkP/10;-- clkP*(8+4)+clkP/2
	enaI <= '1' after clkP*8+clkP/2+clkP/10;-- clkP*8+clkP/2
	--b0: general control
	process (clk) 
	begin
		if clk='1' and clk'event then
			if enaI='0' then 
				ld_sub_it <= (others => '0');
			else
				if ld_sub_it="011" then
					ld_sub_it <= (others => '0');
					ld_sub_it_r <= ld_sub_it;
				else
					ld_sub_it <= ld_sub_it + 1;
				end if;
				ld_sub_it_r <= ld_sub_it;
			end if;
		end if;
	end process;
	process (clk) 
	begin
		if clk='1' and clk'event then
			if enaI='0' then 
				id_dloop <= (others => '0');
			elsif ld_sub_it_r="011" then
				id_dloop <= id_dloop + 1;
			end if;
		end if;
	end process; 

	process(clk)
		file f_id: text open read_mode is "./src/stm/Test_matrix/t_id_lnold_zeros_tnu(0).txt";
		file f_od_sm: text open read_mode is "./src/stm/Test_matrix/t_od_synd_zeros_tnu(0).txt";
		file f_od_wmn: text open read_mode is "./src/stm/Test_matrix/t_od_wmn_zeros_tnu(0).txt";
		file f_od_En_it: text open read_mode is "./src/stm/Test_matrix/t_od_En_calc_zeros_tnu(0).txt";
		file f_od_decn: text open read_mode is "./src/stm/Test_matrix/t_od_decn_zeros_tnu(0).txt";
		file f_od_lnnew: text open read_mode is "./src/stm/Test_matrix/t_od_lnnew_zeros_tnu(0).txt";
		variable l_id: line;
		variable v_id: p_type_a6xQLstd;
		variable l_od: line;
		variable v_od_0: std_logic_vector(0 to 5);
		variable v_od_1: std_logic;
		variable l_od_sm: line;
		variable v_od_sm: std_logic;
		variable l_od_wmn: line;
		variable v_od_wmn: std_logic_vector(0 to 5);
		variable l_od_En_it: line;
		variable v_od_En_it: type_a6x4std;
		variable l_od_En: line;
		variable v_od_En_0: p_type_a6xQLstd;
	begin
		if rising_edge(clk) then
			if enaI='1' then
				if not endfile(f_id) then
					readline(f_id,l_id);
					for i in 0 to 5 loop
						read(l_id,v_id(i));
						id_lnold(i) <= v_id(i) after clkP/10;
					end loop;
					readline(f_od_sm,l_od_sm);
					read(l_od_sm,v_od_sm);
					od_sm_f <= v_od_sm  after clkP/10;
					readline(f_od_wmn,l_od_wmn);
					read(l_od_wmn,v_od_wmn);
					od_wmn_f <= v_od_wmn  after clkP/10;
					readline(f_od_En_it,l_od_En_it);
					for i in 0 to 5 loop
						read(l_od_En_it,v_od_En_it(i));
						ld_En_it_f(i) <= v_od_En_it(i)  after clkP/10;
					end loop;
				end if;
			end if;
			enaI_r <= enaI;
			if enaI_r='1' then
				if not endfile(f_od_decn) then
					readline(f_od_decn,l_od);
					read(l_od,v_od_0);
					od_decn_f <= v_od_0 after clkP/10;
--					od_decn_c <= od_decn;
--					read(l_od,v_od_1);
--					od_parity_f <= v_od_1;
				end if;
				if od_decn_f/=od_decn_c then --or od_parity_f/=od_parity_c then 
					cnt_decn_error <= cnt_decn_error + 1;
				end if;
				if not endfile(f_od_lnnew) then
					readline(f_od_lnnew,l_od_En);
					for i in 0 to 5 loop
						read(l_od_En,v_od_En_0(i));
						od_lnnew_f(i) <= v_od_En_0(i);
						ld_En_f(i) <= od_lnnew_f(i)(8 downto 2);
						ld_En(i) <= od_lnnew(i)(8 downto 2);
						ld_zn_f(i) <= od_lnnew_f(i)(1);
						ld_zn(i) <= od_lnnew(i)(1);
						ld_yr_f(i) <= od_lnnew_f(i)(0);
						ld_yr(i) <= od_lnnew(i)(0);
					end loop;
				end if;
			end if;
			if ld_En_f/=ld_En then
						cnt_En_error <= cnt_En_error + 1;
			end if;
			if ld_zn_f/=ld_zn then
						cnt_zn_error <= cnt_zn_error + 1;
			end if;
			if ld_yr_f/=ld_yr then
						cnt_yr_error <= cnt_yr_error + 1;
			end if;
			if endfile(f_od_lnnew) then
				end_sim <= '1';
			end if;
		end if;
	end process;
	od_decn_c <= od_decn after clkP/10;
	----
	assert end_sim='0'
		report "End of simulation...."
		severity FAILURE;
end tb;
